import * as moment from 'moment';
import { AfterLoad, BaseEntity, Column, CreateDateColumn, UpdateDateColumn } from 'typeorm';

export class BaseModel extends BaseEntity {
  @Column({
    type: 'timestamp',
    default: () => moment().utcOffset(0).toDate(),
  })
  timestamp: Date;

  @CreateDateColumn({
    type: 'timestamp',
    default: () => moment().utcOffset(0).toDate(),
  })
  created_at: Date;

  @UpdateDateColumn({
    type: 'timestamp',
    default: () => moment().utcOffset(0).toDate(),
  })
  updated_at: Date;

  @AfterLoad()
  updateTimestampFromUpdatedAt() {
    this.timestamp = this.updated_at;
  }
}
